<template>
  <div id="map">
    <slot></slot>
  </div>
</template>

<script>
export default {
  props: ["json", "currentregion"],
  mounted() {
    this.worldMapObject = {
      color: "#910b1c",
      hover: "#910b1c",
      regions: {}
    };
    this.map = $("#map");
    this.svg = this.map.find("svg");
    this.paths = this.svg.find("path");
    this.popup = this.map.find("#popup");
    this.popup_title = this.popup.find(".popup-header .data");
    this.popup_description = this.popup.find(".description");
    this.width = this.svg.width();
    this.height = this.svg.height();
    this.initMap();
  },
  methods: {
    initMap: function() {
      this.createRegions(JSON.parse(this.json), this.currentregion);
      for (let [key, value] of Object.entries(this.worldMapObject.regions)) {
        value.states.forEach(e => {
            let region =  this.map.find("path[data-id='" + e + "']");
            region.data("region", key);
            region.addClass("cursor-pointer"); 
        });
      }
      this.initClick();
      this.initPopup();
      if (this.currentregion != null && this.currentregion.name != "Global") {
        this.setDefaultPopup();
      }
    },
    createRegions: function(json, currentRegion) {
      for (var region in json) {
        this.createRegion(
          region,
          json[region].coming_soon,
          json[region].country_codes,
          json[region].links,
          json[region].x_coordinate,
          json[region].y_coordinate
        );
      }
    },
    createRegion: function(regionName, comingSoon, countryCodes, links,xCoord, yCoord) {
      this.worldMapObject.regions[regionName] = {
        name: regionName,
        states: countryCodes.split(",").map(code => code.trim()),
        description: this.createLinkList(comingSoon, links),
        xCoord: xCoord,
        yCoord: yCoord
      };
    },
    createLinkList: function(comingSoon, links) {
      let list = "<ul>";
      if (comingSoon) {
        list += "<li><a href='/our-products'>Coming Soon</a></li>";
      } else {
        for (var i = 0; i < links.length; i++) {
          list +=
            '<li><a target="' + links[i].link.target + '" href="' +
            links[i].link.url +
            '">' +
            links[i].link.title +
            "</a></li>";
        }
      }
      return (list += "</ul>");
    },
    initPopup: function() {
      this.popup.find(".close").on("click", e => {
        this.popup.css("display", "none");
        this.popup.removeClass("recommended");
      });
    },
    initClick: function() {
      this.svg.on("click", e => {
        this.width = this.svg.width();
        this.height = this.svg.height();
        this.popup.css("display", "none");
        this.popup.removeClass("recommended");
        if (e.target.tagName !== "path") {
          return;
        }
        var region = $(e.target).data("region");
        if ($(e.target).data("region") != null) {
          var regionObject = this.worldMapObject.regions[region];
          this.setPopupData(
            regionObject.name,
            regionObject.description
          );
          var x = e.pageX - this.svg.offset().left + 20;
          var y = e.pageY - this.svg.offset().top - 35;
          this.popup.css({
            display: "block",
            left: (x / this.svg.width())*100 + "%",
            top: (y / this.svg.height())*100 + "%"
          });
          if (regionObject.name == this.currentregion) {
            this.popup.addClass("recommended");
          }
        }
      });
    },
    getStatesInRegion: function(region) {
      let statesInRegion = this.paths.filter(function() {
        return $(this).data("region") === region;
      });
      return statesInRegion;
    },
    setDefaultPopup: function() {
      var region = this.worldMapObject.regions[this.currentregion];
      if (region == null || region == undefined || region.name == "Global") return;
      var statesInRegion = this.getStatesInRegion(this.currentregion);
      this.setPopupData(region.name, region.description);
        this.popup.css({
            display: "block",
            left: region.xCoord + "%",
            top: region.yCoord + "%"
        }); 
        this.popup.addClass("recommended");
    },
    setPopupData: function(name, description) {
      this.popup_title.html(name);
      this.popup_description.html(description);
    }
  }
};
</script>